Subject: Re: bug#15398: 24.3; Frame redraw completely screwed

From: Jan Djärv <[email-masked]>
Date: Fri, 20 Sep 2013 11:32:11 +0200

Hello.

20 sep 2013 kl. 10:00 skrev Dmitry Antipov <[email-masked]>:

> On 09/20/2013 10:47 AM, Jan Djärv wrote:
> 
>> 20 sep 2013 kl. 05:41 skrev Dmitry Antipov <[email-masked]>:
>> 
>>> On 09/19/2013 08:41 PM, Jan Djärv wrote:
>>> 
>>>> I don't recall all the details, but I think the comment actually means "for GTK 2.6 and newer".
>>> 
>>> Ugh. Reverted in r114402 (for visible frames; in general, I think
>>> that it is possible to handle Expose events a bit more intelligently).
>> 
>> Not as long as we do pure X-calls on Gtk-widgets.
> 
> Yes, mixing Xlib and Gtk is ugly. But I would like to get your comments on this first
> (also I'm looking for brave testers).
> 
> Dmitry
> 
> <gtk_clear_expose.patch>

This simply does not work.  It assumes there is only one frame per root window, which is wrong.
It assumes Emacs will get Unmap events when something obscuring it goes away, this is wrong (other applications may cover Emacs and the go away).

Any optimization attempt in this area is futile, it will lead to errors for a very small performance benefit.  The time is better spent into doing a proper double buffer solution.

	Jan D.